;*****************************************************************************
;
;                            L   A   D   O   C
;
;              Lisp Programmsammlung mit Dialogboxinterface
;                zur Dokumentation der Zeichnungsstruktur
;
;                         V  E  R  S  I  O  N    1.00
;
;
;
;
;*****************************************************************************

(defun C:LADO
 (/
; Deklaration der lokale Variablen
  EARX_ALTC     ; Vorhandener Wert CMDECHO
  EARX_ALTE     ; Vorhandener Wert EXPERT
  EARX_BRK      ; Abbruch-Flag
  EARX_DATEI    ; Dateideskriptor der Dialogbox
  EARX_AMAX     ; Vorhandener Wert von Maxsort
  EARX_VER      ; Versionsnummer fr Dialogbox
  EARX_LIZ      ; Name des Lizenznehmers fr Ausdruck
  EARX_LIZ_TILE ; Name des Lizenznehmers fr Dialogbox
  EARX_CRT1     ; Copyright-Textzeile 1
  EARX_CRT2     ; Copyright-Textzeile 2
  EARX_LIST     ; Liste  der Tabelleneintrge
  EARX_TXT      ; Listentext zum Ausdrucken
  EARX_STAT     ; Rckgabewert der Optionsabfrage
  EARX_ALL      ; Auswahlliste fr Mehrfachwahlfenster
  EARX_SLL      ; Ergebnisliste Mehrfachauswahl
  EARX_HOME     ; Suchpfad fr Hilfsdateien
  EARX_HOME1    ; Fr Lisp konvertierter Suchpfad fr Hilfsdateien
  EARX_DCL      ; DCL-Datei mit Pfad
  EARX_LDCL     ; Lnge des Namens der bentigten DCL-Datei

;Deklaration von Funktionen als lokale Variablen
  EARX:ALTERR  ; Alte Error-Funktion vor Programmstart
  EARX:ALTSET  ; Speichern vorhandener Einstellungen
  EARX:SETALT  ; Wiedereinstellen der gespeicherten Einstellungen
  EARX:ERR     ; Funktion fr den Abbruch-Fall
  EARX:ABR     ; Abbruch-Flag setzen
  EARX:DBOX    ; Abfrage der auszufhrenden Programmoptionen
  EARX:FINDS   ; Auflisten der Tabelleneintrge
  EARX:DATUM   ; Errechnen des Datums
  EARX:TITEL   ; Ausgabe des Listenkopfes
  EARX:SSL     ; Elementeliste aus einem Auswahlsatz
  EARX:MLIST   ; Auswahlliste fr Mehrfachwahl-Dialog
  EARX:ASEL    ; Mehrfachwahl auf Alle setzen
  EARX:UNSEL   ; Mehrfachwahl zurcksetzen
  EARX:AWCHK   ; Mehrfachauswahl weiterverarbeiten
  EARX:LCHK    ; Mehrfachauswahl in Dialog-Liste
  EARX:LDOC    ; Layerliste erstellen
  EARX:PLOTL   ; Layer einzeln ausplotten
  EARX:LCNV    ; Layer konvertieren
  EARX:BDOC    ; Blockliste erstellen
  EARX:BLEG    ; Blocklegende erstellen
  EARX:VDOC    ; Systemvariablenliste erstellen
  EARX:TDOC    ; Textstilliste erstellen
  EARX:TCNV    ; Textstile konvertieren
  EARX:FDOC    ; Textfonts dokumentieren
 )

; ****************************************************************************
; 
;            DEFINITION DER UNTERPROGRAMME ALS LOKALE FUNKTIONEN
;
; ****************************************************************************


;---- UNTERPROGRAMME PROGRAMMUMGEBUNG EINRICHTEN UND RCKSETZEN --------------

 (defun EARX:ALTSET() 
  (command "._UNDO" "_GROUP")                 ;Den Gruppenmodus starten
  (setq EARX_AMAX (getvar "MAXSORT")          ;damit nach Programm-Abbruch
        EARX_ALTC (getvar "CMDECHO")          ;alles mit einem Z-Befehl
        EARX_ALTE (getvar "EXPERT")           ;zurckgesetzt werden.
  )

  (setvar "CMDECHO" 0)
  (setq EARX:ALTERR  *ERROR* 
        *ERROR*      EARX:ERR
  )
  (princ)
 )

 (defun EARX:SETALT() 
  (command "._UNDO" "_E")
  (setvar "CMDECHO" EARX_ALTC)
  (setvar "EXPERT" EARX_ALTE)
  (setvar "MAXSORT" EARX_AMAX)
  (setq *ERROR* EARX:ALTERR)
  (grtext)
  (princ)
 ) 

 (defun EARX:ERR(MSG) 
  (if (or (= MSG "Function cancelled") (= MSG "Funktion abgebrochen")) 
   (princ "\n! Das Programm wurde abgebrochen !  ") 
   (princ (strcat "\nFolgender Fehler wurde gemeldet : " MSG))
  ) 
  (EARX:SETALT) 
  (princ)
 ) 

 (defun EARX:ABR()(setq EARX_BRK T EARX_STAT 0))

; ============================================================================
; 
;                  U N T E R P R O G A M M    E A R X : D B O X
;
; ============================================================================
; Abfrage der auszufhrenden Programmoptionen


 (defun EARX:DBOX (/ EARX_DATEI POSITION ZEICHEN)
;;;Wenn noch keine DCL - Info
;(if EARX_DCL (progn (princ "\nEARX_DCL = ")(princ EARX_DCL)))

  (if (null EARX_DCL)
   (setq EARX_DCL "Ladoc.DCL" EARX_LDCL 9) ;ANSI-Text
  )
  (if (not EARX_HOME1)
   (progn ; Noch kein HOME-Verzeichnis
;;;DCL-Datei suchen
  (if (not (setq EARX_DCL (findfile EARX_DCL)))
   (progn ;Nix gefunden
     (progn ;WIN
      (alert "Datei Ladoc.DCL nicht gefunden! Bitte lokalisieren!")
      (if (setq EARX_DCL (getfiled"Suche nach Ladoc.DCL" "Ladoc" "DCL" 8))
;;;Gefunden
       (if (not (setq EARX_DATEI (load_dialog EARX_DCL)))
        (progn
         (princ "Keine Dialog-Datei Ladoc.DCL gefunden!")
         (exit)
        )
        (progn
         (setq EARX_LDCL (- (strlen EARX_DCL) EARX_LDCL))
         (setq EARX_HOME (substr EARX_DCL 1 EARX_LDCL))
        )
       ); End Gefunden if
       (progn ;Nix
        (princ "Keine Dialog-Datei Ladoc.DCL gefunden!")
        (exit)
       )
      )
     ); End WIN
   );Ende progn kein DCL
;;;progn wenn DCL
   (if (not (setq EARX_DATEI (load_dialog EARX_DCL)))
    (progn
     (alert "Keine Dialog-Datei Ladoc.DCL gefunden!")
     (exit)
    )
    (progn
     (setq EARX_LDCL (- (strlen EARX_DCL) EARX_LDCL))
     (setq EARX_HOME (substr EARX_DCL 1 EARX_LDCL))
    )
   );Ende wenn DCL
  );Ende if

;;;EARX_HOME fr LISP konvertieren
    (setq EARX_HOME1 "" POSITION 0)
    (repeat (strlen EARX_HOME)
     (setq POSITION (+ 1 POSITION)
           ZEICHEN (substr EARX_HOME POSITION 1)
           EARX_HOME1 (strcat EARX_HOME1 (if (= ZEICHEN (chr 92)) "/" ZEICHEN))
     )
    )
   );end progn kein HOME
   (progn ; Ausfhren wenn HOME
    (setq EARX_DATEI (load_dialog EARX_DCL))
   )
  );End if kein HOME

  (if (not (new_dialog "LADOC" EARX_DATEI))
   (progn
    (alert "Falsche Dialog-Datei! - Dialog LADOC nicht gefunden!")
    (exit)
   )
   (progn
    (set_tile "VERSION" EARX_VER)
    (set_tile "LIZENZ" EARX_LIZ_TILE)
    (action_tile "LDOC"   "(done_dialog 10)")
    (action_tile "LPLT"   "(done_dialog 9)")
    (action_tile "accept" "(done_dialog 1)")
    (action_tile "cancel" "(done_dialog 0)")
    (setq EARX_STAT (start_dialog))
    (unload_dialog EARX_DATEI)
   )
  )
 );Ende defun EARX:DBOX

; ============================================================================
; 
;                   U N T E R P R O G A M M    E A R X : F I N D S
;
; ============================================================================
; Listen der in der Tabelle gefundenen Eintragsnamen

 (defun EARX:FINDS
  (TBL       ; Zu bearbeitende Symboltabelle als Parameter
;  MUSTER    ; Es knnte noch eine Musterliste zum herausfiltern 
   /         ; mitgegeben werden
   EARX_DAT  ; Gesamtliste des gefunden Eintrags der Layertabelle
   EARX_NAM  ; Layername
  )

  (setq EARX_LIST nil)  ; Alte Datenliste lschen
  (setq EARX_DAT (tblnext TBL T))

  (while EARX_DAT
   (setq EARX_NAM (cdr (assoc 2 EARX_DAT)))
   (setq EARX_LIST (cons EARX_NAM EARX_LIST)) 
   (setq EARX_DAT (tblnext TBL))
  );while

  (setq EARX_LIST EARX_LIST)
 );defun
; ============================================================================
; DDDOC
;                 U N T E R P R O G A M M    E A R X : D A T U M
;
; ============================================================================
; Errechnen des Datums zur Druckausgabe

 (defun EARX:DATUM  ( / EARX_DATUM)
  (setq EARX_DATUM (rtos (getvar "CDATE") 2 10))
  ; Globale Variable Datumstext EARX_TXT
  (setq EARX_TXT
   (strcat
    (substr EARX_DATUM 7 2)    ;Tag
    "."
    (substr EARX_DATUM 5 2)    ;Monat
    "."
    (substr EARX_DATUM 3 2)    ;Jahr
    " "
    (substr EARX_DATUM 10 2)   ;Stunden
    ":"
    (substr EARX_DATUM 12 2)   ;Minuten
    " UHR"
   )
  )
 )

; ============================================================================
; DDDOC
;                 U N T E R P R O G A M M    E A R X : T I T E L
;
; ============================================================================
; Ausgabe des Listenkopfes

 (defun EARX:TITEL
  (DATNAM  FLAG / ; Dateidescriptor
   EARX_DATEI
  )
  (setq EARX_DATEI (open DATNAM "w"))
  (princ 
   (strcat
    EARX_TIT
    "\n\nZeit: "
    EARX_TXT
    "   Zeichnung: "
    (getvar "DWGNAME")
    "\n\n"
   )
   EARX_DATEI
  )
  (if (= FLAG "L")
   (princ 
    (strcat
     "                                                                   Ent-"
     "\n                               "
     "       "
     "                 "
     "EIN "
     "Frieren "
     "sperrt "
     "ANZAHL"
     "\n"
     "LAYERNAME                      "
     "FARBE  "
     "LINIENTYP        "
     "--- "
     "------- "
     "------ "
     " Leer "
     "\n"
     "                               "
     "       "
     "                 "
     "AUS "
     "Tauen   "
     "Sperre "
     " Xref "
     "\n\n"
    )
    EARX_DATEI
   )
  )
  (close EARX_DATEI)
 )

; ----------------------------------------------------------------------------
; 
;                        U N T E R P R O G R A M M    EARX:SSL
;
; ----------------------------------------------------------------------------

;******************************* EARX:SSL ***************************************
; Bildet eine Elementeliste aus einem Auswahlsatz - fr Mehrfachbefehle.
; ----------------------------------------------------------------------

(defun EARX:SSL(SS / N P)
  (setq N (sslength SS))
  (repeat N
    (setq N (1- N)
          P (cons (ssname SS N) P)
    )
  )
)

; ----------------------------------------------------------------------------
; 
;                        U N T E R P R O G R A M M    EARX:MLIST
;
; ----------------------------------------------------------------------------

  (defun EARX:MLIST ()
   (start_list "SL")                    
   (foreach ITEM EARX_ALL (add_list ITEM))
   (end_list)
  )

; ----------------------------------------------------------------------------
; 
;                        U N T E R P R O G R A M M    EARX:ASEL
;
; ----------------------------------------------------------------------------

  (defun EARX:ASEL (/ IDX)                
   (setq IDX 0)                  
   (repeat (length EARX_ALL)          
    (set_tile "SL" (itoa IDX))
    (setq IDX (1+ IDX))
   )
   (mode_tile "S_A" 1)           
   (mode_tile "C_A" 0)           
   (mode_tile "accept" 0)        
   (EARX:LCHK)
   (setq AWSOPT "Jeder Text")
  )

; ----------------------------------------------------------------------------
; 
;                        U N T E R P R O G R A M M    EARX:UNSEL
;
; ----------------------------------------------------------------------------

  (defun EARX:UNSEL ()               
   (set_tile "SL" "")             
   (mode_tile "C_A" 1)             
   (mode_tile "S_A" 0)             
   (mode_tile "accept" 0)          
   (setq EARX_SLL '())                  
   (EARX:MLIST)                     
   (setq AWSOPT "Nichts")
  )

; ----------------------------------------------------------------------------
; 
;                        U N T E R P R O G R A M M    EARX:AWCHK
;
; ----------------------------------------------------------------------------

  (defun EARX:AWCHK ()                   
   (EARX:LCHK)                            
   (if (= (length EARX_SLL) (length EARX_ALL))
    (mode_tile "S_A" 1)
    (mode_tile "S_A" 0)
   )
   (if (/= (get_tile "SL") "")      
    (progn                        
     (mode_tile "accept" 0)
     (mode_tile "C_A" 0)
    )
    (progn                         
     (mode_tile "accept" 0)
     (mode_tile "C_A" 1)
    )
   )
  )

; ----------------------------------------------------------------------------
; 
;                        U N T E R P R O G R A M M    EARX:LCHK
;
; ----------------------------------------------------------------------------

  (defun EARX:LCHK (/ SDL PL INDEX)                   
   (setq SDL (get_tile "SL") EARX_SLL '())      
   (setq INDEX 1 PL "" SDL (strcat SDL " "))  
   (while (/= INDEX (1+ (strlen SDL)))
    (if (/= (substr SDL INDEX 1) " ")
     (setq PL (strcat PL (substr SDL INDEX 1)))
     (progn                                          
      (setq EARX_SLL (cons (nth (atoi PL) EARX_ALL) EARX_SLL))
      (setq PL "")                             
     )
    )
    (setq INDEX (1+ INDEX))
   )
   (setq AWSOPT "Die gewhlte Liste")
  )

; ============================================================================
; 
;                 U N T E R P R O G A M M    E A R X : L D O C
;
; ============================================================================
; Liste der Layernamen und Zustnde

(defun EARX:LDOC

; Deklaration der Variablen

 ( /
; Deklaration lokale Variable
     EARX_TIT            ; Funktionsbeschreibung im Text
     EARX_LLIST          ; Liste der Layernamen
     EARX_LLIST          ; Layer Liste
     EARX_DWG            ; Zeichnungsname
     EARX_PRF            ; Pfadzuweisung des Zeichnungsnamens
     EARX_PFL            ; Lnge der Pfadzuweisung
     EARX_DATEI          ; Dateiname der Liste
     EARX_TEMP           ; Temporre Variable Layername
     EARX_LAYFLD         ; Feldlnge Layername
     EARX_FARFLD         ; Feldlnge Farbnummer
     EARX_LTPFLD         ; Feldlnge Linientyp
     EARX_LOCKFLD        ; Feldlnge Sperr-Status
     EARX_STATFLD        ; Feldlnge Ein/Aus-Status
     EARX_FREEZFLD       ; Feldlnge Frieren-Tauen
     EARX_INDEX          ; Anzahl der gefundenen Layer

; Funktionen als lokale Variable
     EARX:FORMAT         ; Lokale Funktion zum Formatieren der Ascii-Textausgabe
     EARX:PRINT          ; Lokale Funktion zur Ausgabe der Liste 
     EARX:ASCII          ; Lokale Funktion zur Ascii-Textausgabe
 )

; ============================================================================
; 
;                 L o k a l e   U n t e r f u n k t i o n e n
;
; ============================================================================
; ----------------------------------------------------------------------------
; 
;                U N T E R F U N K T I O N    E A R X : F O R M A T
;
; ----------------------------------------------------------------------------
; Formatieren der ASCII-Textausgabe

 (defun EARX:FORMAT ()

   (setq EARX_LAYFLD "                                ")
;  Layername, Feldlnge 32 Zeichen

   (setq EARX_FARFLD "    ")
;  Farbnummer, Feldlnge 6 Zeichen

   (setq EARX_LTPFLD "               ")
;  Linientyp-Name, Feldlnge 15 Zeichen

   (setq EARX_STATFLD "       ")
;  Ein/Aus Status, Feldlnge 7 Zeichen

   (setq EARX_FREEZFLD "      ")
;  Tau/Frier Status, Feldlnge 6 Zeichen

   (setq EARX_LOCKFLD "    ")
;  Sperr-Status, Feldlnge 7 Zeichen
 )

; ----------------------------------------------------------------------------
; 
;                U N T E R F U N K T I O N    E A R X : A S C I I
;
; ----------------------------------------------------------------------------
; Ausgabe der Liste als ASCII-Text in eine Datei

 (defun EARX:ASCII ()
    (princ
     (strcat 

      EARX_TEMP                                            ;Layername
      (substr EARX_LAYFLD (strlen EARX_TEMP))                ;Tabulator

      (rtos EARX_FARBE 2 0)                                ;Farbnummer
      (substr EARX_FARFLD (strlen (rtos EARX_FARBE 2 0)))    ;Tabulator

      EARX_LTYPE                                           ;Linientyp
      (substr EARX_LTPFLD (strlen EARX_LTYPE))               ;Tabulator

      EARX_STATUS                                          ;Ein/Aus-Status
      (substr EARX_STATFLD (strlen EARX_STATUS))             ;Tabulator

      EARX_FEARXTAT                                          ;Tauen/Frieren-Status
      (substr EARX_FREEZFLD (strlen EARX_FEARXTAT))            ;Tabulator

      EARX_LOCKSTAT                                        ;Sperr-Status
      (substr EARX_LOCKFLD (strlen EARX_LOCKSTAT))           ;Tabulator

      EARX_ELEMENTE                                        ;Nutzung
      "\n"                                               ;Umbruch
     );strcat
     EARX_FILE                                             ;Dateidiskriptor
    );princ
 );defun

; ----------------------------------------------------------------------------
; 
;                U N T E R F U N K T I O N    E A R X : P R I N T
;
; ----------------------------------------------------------------------------
; Ausgabe der Layereigenschaften in eine Datei

(defun EARX:PRINT
                  (/
                   EARX:TPREP ; Ermittlung der Layereigenschaften
                   EARX_FILE ; Dateidesriptor
                   EARX_FEARXTAT ; Frieren-Tauen-Status
                   EARX_LOCKSTAT ; Sperr-Status
                   EARX_STATUS ; Ein/Aus-Status
                   EARX_FARBE ; Farbnummer
                   EARX_LTYPE ; Linientypname
                   EARX_LEIG ; Summe der Eigenschafts-Flags
                   EARX_LELEM ; Elemente auf dem Layer
                   EARX_LANZ ; Elementanzahl
                   EARX_ANZS ; Elementanzahl als Text
                   EARX_ELEMENTE ; Nutzungs-Status
                   EARX_LYERDAT ; Liste der Daten eines Layers
                   EARX_T ; Nichtkonforme Layernamen
                   COUNTER ; Bearbeitungszhler fr Anzeige                
                  )
; ----------------------------------------------------------------------------
; 
;                U N T E R F U N K T I O N    E A R X : T P R E P
;
; ----------------------------------------------------------------------------
;Ermitteln der Layereigenschaften

(defun EARX:TPREP ()

 (if (minusp (cdr (assoc 62 EARX_LYERDAT)))
  (setq EARX_STATUS " AUS")
  (setq EARX_STATUS " EIN")
 ) ;_ end of if

 (setq EARX_FARBE (abs (cdr (assoc 62 EARX_LYERDAT))))
 (setq EARX_LTYPE (cdr (assoc 6 EARX_LYERDAT)))
 (if (> (strlen EARX_LTYPE) 15) ; Begrenzen des Linientypnamens
  (setq EARX_LTYPE (substr EARX_LTYPE 1 15)) ; auf 15 Zeichen
 ) ;_ end of if
 (setq EARX_LEIG (cdr (assoc 70 EARX_LYERDAT)))
 (while (> EARX_LEIG 0.5)
  (cond
   ((>= EARX_LEIG 64) ;64 = Prfung
    (setq EARX_LEIG (- EARX_LEIG 64))
   )
   ((>= EARX_LEIG 32) ;32 = XREF ohne Fehler
    (setq EARX_LEIG     (- EARX_LEIG 32)
          EARX_ELEMENTE "     X"
    ) ;_ end of setq
   )
   ((>= EARX_LEIG 16) ;32 = XREF allgemein
    (setq EARX_LEIG     (- EARX_LEIG 16)
          EARX_ELEMENTE "     X"
    ) ;_ end of setq
   )
   ((>= EARX_LEIG 4) ;4 = Gesperrt
    (setq EARX_LOCKSTAT "S"
          EARX_LEIG     (- EARX_LEIG 4)
    ) ;_ end of setq
   )
   ((>= EARX_LEIG 2) ;2 = Neufrier
    (setq EARX_LEIG (- EARX_LEIG 2))
   )
   ((>= EARX_LEIG 1) ;1 = Gefrohren
    (setq EARX_FEARXTAT "F"
          EARX_LEIG     (- EARX_LEIG 1)
    ) ;_ end of setq
   )
  ) ;_ end of cond
 ) ;_ end of while

 (if (not (= EARX_ELEMENTE "     X"))
  (if (setq EARX_LELEM (ssget "x" (list (cons 8 EARX_TEMP))))
 ;wenn Elemente
   (progn ;Anzahl bestimmen
    (setq EARX_LANZ (itoa (sslength EARX_LELEM)))
    (setq EARX_ANZS (strlen EARX_LANZ))
    (cond
     ((> EARX_ANZS 6) (setq EARX_ELEMENTE "> 1MIO"))
     ((= EARX_ANZS 6) (setq EARX_ELEMENTE EARX_LANZ))
     ((= EARX_ANZS 5)
      (setq EARX_ELEMENTE (strcat " " EARX_LANZ))
     )
     ((= EARX_ANZS 4)
      (setq EARX_ELEMENTE (strcat "  " EARX_LANZ))
     )
     ((= EARX_ANZS 3)
      (setq EARX_ELEMENTE (strcat "   " EARX_LANZ))
     )
     ((= EARX_ANZS 2)
      (setq EARX_ELEMENTE (strcat "    " EARX_LANZ))
     )
     ((= EARX_ANZS 1)
      (setq EARX_ELEMENTE (strcat "     " EARX_LANZ))
     )
    ) ;_ end of cond
   ) ;_ end of progn
  ) ;_ end of if
 ) ;_ end of if
 (EARX:ASCII)
) ;End defun

; --------------------------- O b e r p r o g r a m m ------------------------

 (terpri)
 (setq COUNTER 0 EARX_FILE (open EARX_DATEI "a")
       )

 (while (setq EARX_TEMP (car EARX_LLIST))
  (setq EARX_FEARXTAT "T"
        EARX_LOCKSTAT "E"
        EARX_ELEMENTE "     L"
  ) ;_ end of setq
  (if
    ;(= EARX_TEMP (strcase EARX_TEMP))
    (setq EARX_LYERDAT (tblsearch "LAYER" EARX_TEMP))
   (EARX:TPREP)
  ) ;End if Konform
  (setq EARX_LLIST (cdr EARX_LLIST) COUNTER (1+ COUNTER))
  (princ (strcat "\r" (itoa COUNTER) " Layer bearbeitet."))
 ) ;while

 (if EARX_T
  (progn
   (setq EARX_T
    (strcat
     "Warnung! Folgende Layer:\n"
     EARX_T
     "\nhaben keine AutoCAD-konformen Layernamen und knnen zu Datenverlust fhren!"
     "\nDiese Layer sind sofort aus der Zeichnung zu entfernen!"
    ) ;_ end of strcat
   ) ;_ end of setq
   (write-line EARX_T EARX_FILE)
  )
 )

 (close EARX_FILE)
) ;defun EARX:PRINT

; ============================================================================
; 
;                H A U P T F U N K T I O N    E A R X : L D O C
;
; ============================================================================

; Meldung ausgeben
   (princ "\nEARX:LADOC  Version 1.00")
   (princ "\nErzeugt eine Liste der Layernamen und Zustnde. (c) CADwiesel 2001\n")

 ;  die Layernamen in LLIST speichern
   (setq EARX_LLIST (EARX:FINDS "LAYER")) 

;  die Layernamen in LLIST alphabethisch sortieren
   (setq EARX_LLIST (acad_strlsort EARX_LLIST))

;  Name der Ausgabedatei festlegen
   (setq EARX_DWG (substr (getvar "DWGNAME") 1 (- (strlen (getvar "DWGNAME")) 4)))

   (if (setq EARX_DATEI (getfiled "LAYER-LISTEN" EARX_DWG  "LSD" 1))
    (progn
     (princ "\nDie Auswertung wird in die Datei ")
     (princ EARX_DATEI)
     (princ " geschrieben.\nDiese Datei kann dann gedruckt oder weiterbearbeitet werden.")
     (princ "\n\nDie berprfung der Elemente der einzelnen Layer erfordert einige Minuten Zeit!")
     (princ "\nBitte etwas Geduld!\n")
     (setq EARX_INDEX 1)
     (tblnext "LAYER" T)
     (while (tblnext "LAYER")
      (setq EARX_INDEX (1+ EARX_INDEX))
     )
     (princ (strcat (itoa EARX_INDEX) " Layer gefunden."))
     (setq EARX_TIT
      (strcat
       "\n\n               D A T E N A U S T A U S C H - M A N A G E M E N T"
       "\n\n                        Aufzeichnung der Layer-Zustnde"
       "\n\nDokumentation von " (itoa EARX_INDEX) " gefundenen Layern:"
      )
     )

;  Datum zum Drucken
     (EARX:DATUM)

;  Ausgabe des Listenkopfes
     (EARX:TITEL EARX_DATEI "L")

;  Formatieren der ASCII-Textausgabe
     (EARX:FORMAT)

;  Ausgabe der Layereigenschaften in eine Datei 
     (EARX:PRINT)

;  Befehlsende- Meldung
     (princ "\nDie Auswertung ist jetzt beendet!")

    ); progn
   ); if

;  Kein nil
   (princ)

 );defun Hauptfunktion

; ============================================================================
; 
;                  U N T E R P R O G A M M    E A R X :  P L O T L
;
; ============================================================================


 (defun EARX:PLOTL
  (/
;;;Lokale Variable
   BEZ     PRJ     GBEZ     EARX_ALL      EARX_PL_DEVICE
   ZNAM    P1      MIND     EFP
   FAKTOR  NAMLST  EARX_SLL EARX_DATEI
;;;Funktionen als lokale Variable
   EARX:FRMT
  )
; ----------------------------------------------------------------------------
; 
;                  U N T E R F U N K T I O N    E A R X : F R M T
;
; ----------------------------------------------------------------------------

  (defun EARX:FRMT
   (LISTE
    /
    INDEX INDLEN SUBEL ELEM ETYP PLNAM FP1 FP2 PDAT CLINE MSG LAYANA TRUENAME
    )
   (setq INDEX 0)
;;;Fr jeden Eintrag der bergebenen Plotliste
   (foreach ITEM LISTE
    (EARX:DATUM)
    (setq INDLEN (strlen (itoa INDEX)))
;;;Festlegung des individuellen Plotfilenamens
    (cond
     ((= INDEX 0) (setq PLNAM "LP00000"))
     ((= INDLEN 4) (setq PLNAM (strcat "LP" (itoa INDEX))))
     ((= INDLEN 4) (setq PLNAM (strcat "LP0" (itoa INDEX))))
     ((= INDLEN 3) (setq PLNAM (strcat "LP00" (itoa INDEX))))
     ((= INDLEN 2) (setq PLNAM (strcat "LP000" (itoa INDEX))))
     ((= INDLEN 1) (setq PLNAM (strcat "LP0000" (itoa INDEX))))
    )
    (command "._UNDO" "_GROUP")
    (setvar "ATTREQ" 0)
    (command (strcat verind "LAYER"))
     (command "_M" ITEM "")
    (setq LAYANA (strcat EARX_HOME1 "LAYANA.DWG"))
    (if (not (setq TRUENAME (findfile LAYANA)))
     (progn
      (setq MSG (strcat "Kann den Block ''" LAYANA "'' nicht finden!"))
      (alert MSG)
      (exit)
     )
    )
    (command (strcat verind "INSERT"))
     (command TRUENAME)
    (command)
    (command)
    (setvar "ATTREQ" 1)
    (command (strcat verind "INSERT"))
    (command "LAYANA" EFP FAKTOR "" "")
    (setq SUBEL (cdr (assoc -2 (tblsearch "BLOCK" "LAYANA"))))
    (while SUBEL
     (setq
      ELEM  (entget SUBEL)
      ETYP  (cdr (assoc 0 ELEM))
      SUBEL (entnext SUBEL)
     )
;;;Ausfllen des Plotstempels
     (if (= ETYP "ATTDEF")
      (progn
       (setq BEZ (cdr (assoc 2 ELEM)))
       (cond
        ((= BEZ "LAYERNAME") (command ITEM))
        ((= BEZ "DATUM") (command EARX_TXT))
        ((= BEZ "ZEICHNUNGSNAME") (command ZNAM))
        ((= BEZ "PROJEKTNAME") (command PRJ))
        ((= BEZ "GESCHOSSBEZEICHNUNG") (command GBEZ))
        ((= BEZ "COPYRIGHT1") (command EARX_CRT1))
        ((= BEZ "COPYRIGHT2") (command EARX_CRT2))
       )
      )
     )
    )
    (command)
    (command)
    (command "ZOOM" "_E")
    (setq FP1 (getvar "EXTMIN"))
    (setq FP2 (getvar "EXTMAX"))
    (command "ZOOM" "0.9x")

(setq PDAT (open EARX_PL_DEVICE "r"))
(while (setq CLINE (read-line PDAT))
;;;Befehlssprache kennt vier Ausdrcke die interpretiert werden
 (cond
  ((= CLINE "RETURN")
   (command "")
  )
  ((= CLINE "PUNKT1")
   (command FP1)
  )
  ((= CLINE "PUNKT2")
   (command FP2)
  )
  ((= CLINE "PLOTNAME")
   (command PLNAM)
  )
;;;Alle anderen Ausdrcke werden einfach bernommen
  (T
   (command CLINE)
  )
 )
)
(close PDAT)
;;;  (cond
;;;    ((= acver "14")
;;;    (command (strcat verind "plot"))
;;;     (command "_w" FP1 FP2 "_N")
;;;     )
;;;    ((= acver "15")
;;;    (command (strcat verind "plot"))
;;;     (command "j" "Model" "" "" "M" "Q" "N" "F" FP1 FP2 "A" "z" "N" "." "j" "N" "N" "N" "J")
;;;    )
;;;   )

    (command "._UNDO" "_END")
    (command "._UNDO" "")
    (setq INDEX (1+ INDEX))
   );foreach
   (command "._UNDO" "")
  );defun frmt

; ============================================================================
; 
;                  H A U P T F U N K T I O N    E A R X : P L O T L
;
; ============================================================================

  (setq EARX_SLL '())
  (setq NAMLST (EARX:FINDS "LAYER"))
  (if (> (length NAMLST) 0)
   (progn
    (foreach ELMNT NAMLST              ; Warum keine Xref?
      (setq EARX_ALL (cons ELMNT EARX_ALL))
    )
;;;Nur ntig wenn mehrere Layer
    (setq EARX_ALL (acad_strlsort EARX_ALL))
   )
  )

;;;Layer zum Plotten auswhlen
  (setq EARX_DATEI (load_dialog EARX_DCL))
  (if (not (new_dialog "MSEL" EARX_DATEI))
   (progn
    (alert "Falsche Dialog-Datei! Kann den Dialog ''MSEL'' nicht finden!")
    (exit)
   )
  )
  (set_tile "MOTTO" "Gewhlte Layer separat plotten")
  (mode_tile "accept" 1)
  (mode_tile "C_A" 1)
  (EARX:MLIST)
  (action_tile "SL" "(EARX:AWCHK)")
  (action_tile "cancel" "(setq EARX_SLL '()) (done_dialog)")
  (action_tile "S_A" "(EARX:ASEL)")
  (action_tile "C_A" "(EARX:UNSEL)")
  (action_tile "accept" "(done_dialog)")
  (start_dialog)
  (unload_dialog EARX_DATEI)
  (if EARX_SLL
;;;Wenn etwas gewhlt wurde
   (if (setq EARX_PL_DEVICE (getfiled "Auswahl der Plottereinstellung" "" "PDT" 4))
    (progn
     (initget 1)
     (setq PRJ (getstring T "Bitte den Projektnamen eingeben : "))
     (initget 1)
     (setq GBEZ (getstring T "Bitte die Geschossbezeichnung eingeben : "))
     (setq ZNAM (getvar "DWGNAME"))
     (setvar "EXPERT" 5)
     (command "._UCS" "_W")
     (command (strcat verind "LAYER"))
     (command "_T" "*" "_ON" "*" "")
     (command "._ZOOM" "_E")
     (setq P1 (getvar "EXTMIN"))
     (setq MIND (* (getvar "VIEWSIZE") -0.1))
     (setq EFP (list (+ MIND (car P1)) (+ MIND (cadr P1))))
     (setq FAKTOR (* (getvar "VIEWSIZE") 1.5))
     (command (strcat verind "LAYER"))
     (command "_OFF" "*" "")
     (setvar "CMDDIA" 0)
     (setvar "ATTDIA" 0)
     (EARX:FRMT EARX_SLL)
     (command "._UNDO" "")
     (setvar "EXPERT" 0)
     (setvar "CMDDIA" 1)
     (setvar "ATTDIA" 1)
    );progn
   );Ende - was gewhlt
   (princ "\nKeine Layer zum Plotten gewhlt!")
  );if
 );defun



; ============================================================================
; 
;                  U N T E R P R O G A M M    E A R X :  B L E G
;
; ============================================================================


;;; (defun EARX:BLEG
;;;  (/
;;;;;;Lokale Variable
;;;   BEZ       PRJ       P1         GBEZ           ZNAM
;;;   MIND      EFP       FAKTOR     BPLOT          NAMLST
;;;   EARX_SLL  EARX_ALL  EARX_DATEI EARX_PL_DEVICE
;;;;;;Funktionen als lokale Variable
;;;   EARX:FRMT EARX:BPVE
;;;  )
;;;
;;;
;;;
;;;; ----------------------------------------------------------------------------
;;;; 
;;;;                U N T E R F U N K T I O N    E A R X : B P V E
;;;;
;;;; ----------------------------------------------------------------------------
;;;; Rckmeldung der gewhlten Optionen
;;;
;;;  (defun EARX:BPVE () (setq BPLOT (get_tile "TASTEN")))
;;;
;;;
;;;; ============================================================================
;;;; DDDOC2
;;;;                  H A U P T F U N K T I O N    E A R X : B L E G
;;;;
;;;; ============================================================================
;;;
;;;  (setq EARX_SLL '())
;;;  (setq NAMLST (EARX:FINDS "BLOCK"))
;;;  (if (> (length NAMLST) 0)
;;;   (foreach ELMNT NAMLST
;;;    (if
;;;     (and
;;;;;;Dies knnten auch Optionen werden!
;;;      (/= (substr ELMNT 1 1) "*") ;Keine Systemblcke
;;;      (= (wcmatch ELMNT "ACIS*,ADP_*,AME*,AGR_*,ACADGRAF*,RAUMTEXT,MASSEN") NIL); Kein Mll
;;;     )
;;;     (setq EARX_ALL (cons ELMNT EARX_ALL))
;;;    )
;;;   )
;;;  )
;;;  (setq EARX_ALL (acad_strlsort EARX_ALL))
;;;
;;;;;;Bezeichnungen  eingeben lassen und Plotauswahl 
;;;  (setq EARX_DATEI (load_dialog EARX_DCL))
;;;  (if (not (new_dialog "MSEL" EARX_DATEI))
;;;   (progn
;;;    (alert "Falsche Dialog-Datei! Kann den Dialog ''MSEL'' nicht finden!")
;;;    (exit)
;;;   )
;;;  )
;;;  (set_tile "MOTTO" "Gewhlte Blcke separat plotten")
;;;  (mode_tile "accept" 1)
;;;  (mode_tile "C_A" 1)
;;;  (EARX:MLIST)
;;;  (action_tile "SL" "(EARX:AWCHK)")
;;;  (action_tile "cancel" "(setq EARX_SLL '()) (done_dialog)")
;;;  (action_tile "S_A" "(EARX:ASEL)")
;;;  (action_tile "C_A" "(EARX:UNSEL)")
;;;  (action_tile "accept" "(done_dialog)")
;;;  (start_dialog)
;;;  (unload_dialog EARX_DATEI)
;;;  (if (/= EARX_SLL NIL)
;;;;;;Wenn etwas gewhlt wurde
;;;   (if (setq EARX_PL_DEVICE (getfiled "Auswahl der Plottereinstellung" "" "PDT" 4))
;;;    (progn
;;;     (initget 1)
;;;     (setq PRJ (getstring T "Bitte den Projektnamen eingeben : "))
;;;     (initget 1)
;;;     (setq GBEZ (getstring T "Bitte die Geschossbezeichnung eingeben : "))
;;;     (command "_.REGENAUTO" "EIN")
;;;     (setq ZNAM (getvar "DWGNAME"))
;;;     (setvar "EXPERT" 5)
;;;     (command "._UCS" "_W")
;;;     (command "._REGENAUTO" "AUS")
;;;     (command (strcat verind "LAYER"))
;;;     (command "_THAW" "*" "_ON" "*" "_UNLOCK" "*" "")
;;;     (command "._ERASE" "_ALL" "")
;;;     (command (strcat verind
;;;              "LAYER"))
;;;     (command
;;;              "_SET"
;;;              "0"
;;;              "_THAW"
;;;              "*"
;;;              "_ON"
;;;              "*"
;;;              "_UNLOCK"
;;;              "*"
;;;              ""
;;;     )
;;;     (setvar "CMDDIA" 0)
;;;     (setvar "ATTDIA" 0)
;;;     (EARX:FRMT EARX_SLL)
;;;     (command "._UNDO" "")
;;;     (setvar "EXPERT" 0)
;;;     (setvar "CMDDIA" 1)
;;;     (setvar "ATTDIA" 1)
;;;    )
;;;   );Ende - Was gewhlt
;;;   (princ "\nKeine Blcke zum Plotten gewhlt!")
;;;  );if
;;; );defun

;*****************************************************************************
;
;           H  A  U  P  T  P  R  O  G  A  M  M          D  D  D  O  C
;
;*****************************************************************************


(setvar "CMDECHO" 0)
;(setvar "CMDECHO" 1)

 (EARX:ALTSET)
 (setq EARX_VER   "1.00"
       EARX_CRT1  "erstellt mit LADOC"
       EARX_CRT2  ""
       EARX_CRT2  ""
       EARX_DCL   nil
       EARX_HOME  nil       
       EARX_HOME1 nil
       ACVER        (substr (getvar "acadver") 1 2)
 )
(cond
    ((= acver "14")
    (setq verind "._"))
    ((>= acver "15")
    (setq verind "_-"))
    )

 (setq EARX_LIZ "E R G O   U S E R") ; 17

;Wenn kein EARX_LIZ_TILE definiert ist, auf EARX_LIZ setzen
 (if (not EARX_LIZ_TILE) (setq EARX_LIZ_TILE EARX_LIZ))

 (setq EARX_AMAX (getvar "MAXSORT")

       EARX_BRK nil

       EARX_STAT 20
 )

 (while (> EARX_STAT 1)
  (EARX:DBOX)
  (cond
   ((= EARX_STAT 10)(EARX:LDOC))

   ((= EARX_STAT 9)(EARX:PLOTL))

   ((= EARX_STAT 1)(setq EARX_STAT 0))

   ((= EARX_STAT 0)(EARX:ABR))
  )
 )

 (if EARX_BRK
  (progn
   (EARX:SETALT)
   (command "._U")
  )
  (EARX:SETALT)
 )
 (princ)
)

(princ "\nProgramm LADOC geladen!\nAufruf mit LADO")
(princ)
; Ende des Programms
